%global momorel 4

%global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
%global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")

%define lua_ver 5.2.3

Name:		tolua++
Version:	1.0.93
Release:	%{momorel}m%{?dist}
Summary:	tolua++ is an extended version of tolua, a tool to integrate C/C++ code with Lua.
Group:		Development/Libraries
License:	MIT/X

URL:		http://www.codenix.com/~tolua/
Source0:	http://www.codenix.com/~tolua/%{name}-%{version}.tar.bz2
NoSource:	0
Patch0:     tolua++-1.0.93-no-buildin-bytecode.patch
Patch1:     tolua++-1.0.93-lua52.patch

BuildRequires:	python-devel scons
BuildRequires:	lua-devel = %{lua_ver}
Requires:	python >= 2.5
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description

tolua is a tool that greatly simplifies the integration of C/C++ code with Lua. Based on a cleaned header
file (or extracts from real header files), tolua automatically generates the binding code to access C/C++ 
features from Lua. Using Lua API and tag method facilities, tolua maps C/C++ constants, external variables, 
functions, classes, and methods to Lua.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1 -b .lua52
sed -i 's/\r//' doc/%{name}.html

%build 
scons %{?_smp_mflags} -Q CCFLAGS="%{optflags} $(pkg-config --cflags lua)" tolua_lib=%{solib} LINKFLAGS="-Wl,-soname,lib%{solib}.so" shared=1
# Relink the tolua++ binary, to link it without the soname which we add to
# LINKFLAGS to build a shared lib
gcc -o bin/%{name} src/bin/tolua.o -Llib -l%{solib} -llua -ldl -lm


%install
rm -rf %{buildroot}

mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_libdir}
mkdir -p $RPM_BUILD_ROOT%{_includedir}
install -m 755 bin/%{name}  $RPM_BUILD_ROOT%{_bindir}
install -m 755 lib/lib%{solib}.so $RPM_BUILD_ROOT%{_libdir}
ln -s lib%{solib}.so $RPM_BUILD_ROOT%{_libdir}/libtolua++.so
install -p -m 644 include/%{name}.h $RPM_BUILD_ROOT%{_includedir}
# For use with Patch2 (not working yet)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
install -p -m 644 src/bin/lua/*.lua $RPM_BUILD_ROOT%{_datadir}/%{name}

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-, root, root, -)
%doc README doc/*
%{_bindir}/%{name}
%{_libdir}/lib%{solib}.so
%{_libdir}/libtolua++.so
%{_includedir}/%{name}.h
%{_datadir}/%{name}

%changelog
* Tue Jan 06 2015 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.93-4m)
- rebuild against lua-5.2

* Tue Aug 28 2012 Daniel McLellan <daniel.mclellan@gmail.com>
- (1.0.93-m3)
- adjusted for various architectures

* Tue Aug 28 2012 Daniel McLellan <daniel.mclellan@gmail.com>
- (1.0.93-m2)
- symbolic link added

* Tue Aug 28 2012 Daniel McLellan <daniel.mclellan@gmail.com>
- (1.0.93-m1)
- initial Momonga release
